import 'package:flutter/material.dart';
import 'package:twake/widgets/common/shimmer_loading.dart';

class RoundedShimmer extends StatelessWidget {
  final double size;
  final double opacity;

  RoundedShimmer({this.size = 30, this.opacity = 1.0});

  @override
  Widget build(BuildContext context) {
    return ClipOval(
      child: Opacity(
        opacity: opacity,
        child: ShimmerLoading(
          isLoading: true,
          width: size,
          height: size,
          child: Container(),
        ),
      ),
    );
  }
}
